// $Id: alsa_device.h,v 1.13 2003/03/11 19:40:42 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#ifndef __alsa_device_h__
#define __alsa_device_h__

#include <string>
#include <iostream>
#include "device.h"
#include "exception.h"

#include <alsa/asoundlib.h>

//----------------------------------------------------------------------
class AlsaDevice : public Device
{
 protected:
  snd_mixer_elem_t* element_;

  unsigned element_type_;
  bool capture_enabled_;

  snd_mixer_selem_channel_id_t left_channel_;
  snd_mixer_selem_channel_id_t right_channel_;

  int normalize(int val, int omin, int omax, int nmin, int nmax) const;


 public:
  AlsaDevice(snd_mixer_elem_t*, const string&) 
    throw(InvalidChannelException);
  virtual ~AlsaDevice();

  bool isPlayback() const;
  bool canCapture() const;
  snd_mixer_elem_t* getElement();

  virtual void mute();
  virtual void unMute();
  bool toggleCapture();
  virtual bool getCapture() const;

  virtual void setLeftValue(unsigned value);
  virtual void setRightValue(unsigned value);
  virtual unsigned getLeftValue() const;
  virtual unsigned getRightValue() const;
};


#endif //__alsa_device_h__
