// $Id: wmmixer.h,v 1.11 2003/02/09 19:28:00 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#ifndef __wmmixer_h__
#define __wmmixer_h__

#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <iostream>
#include <list>
#include <string>

#ifdef __USE_ALSA__
  #include "alsa_mixer.h"
#endif

#ifdef __USE_OSS__
  #include "oss_mixer.h"
#endif

#include "config_reader.h"
#include "dockapp.h"
#include "event_handler.h"
#include "x_handler.h"

#ifndef DEFAULT_THEME
#define DEFAULT_THEME "/usr/local/share/wmmixer/traditional/theme.rc"
#endif

using std::list;
using std::cout;
using std::endl;

class WMMixer 
{
 protected:
  Mixer* mixer_;

/* #ifdef __USE_ALSA__ */
/*   AlsaMixer *mixer_; */
/* #else */
/*   OSSMixer *mixer_; */
/* #endif */
  DockApp      *dockapp_;
  EventHandler *event_handler_;
  
  string display_;
  string position_;
  string theme_;
  string mixer_device_;
  char x_flags_;
  unsigned  wheel_scroll_;
  
  void parseArguments(int, char**);
  void parseConfigurationFile();
  void parseOldConfigurationFile();
  void displayVersion() const;
  void displayUsage(const char*) const;

 public:
  WMMixer(int argc, char** argv);
  virtual ~WMMixer();
  void loop();
  
  static const unsigned DEFAULT_MOUSE_SCROLL = 0x05;
};

#endif //__wmmixer_h__
